# TODO
# - bootstrap fails if /usr/share/pear/.lock doesn't exist (just create it as 644)
# - should understand as php extension (php-pear-Auth):
#   pear/Auth can optionally use package "pecl/vpopmail" (version >= 0.2)
#   pear/Auth can optionally use package "pecl/kadm5" (version >= 0.2.3)
#
%define		_pearname	PEAR
%define		_status		stable
%define		php_min_version 5.0.0
%include	/usr/lib/rpm/macros.php
Summary:	PEAR Base System
Summary(pl.UTF-8):	Podstawowy system PEAR
Name:		php-pear-%{_pearname}
Version:	1.9.4
Release:	4
Epoch:		1
License:	New BSD License
Group:		Development/Languages/PHP
Source0:	http://pear.php.net/get/%{_pearname}-%{version}.tgz
# Source0-md5:	c52b09758e851235e6a93a2c1e1a8ee9
Source1:	http://pear.php.net/get/Console_Getopt-1.2.3.tgz
# Source1-md5:	d7618327f9302a7191893768982de823
Source2:	http://pear.php.net/get/Structures_Graph-1.0.3.tgz
# Source2-md5:	d2d8db74818be5cb0af7def3fc285bfc
Patch0:		%{name}-sysconfdir.patch
Patch5:		%{name}-FHS.patch
URL:		http://pear.php.net/package/PEAR
BuildRequires:	/usr/bin/php
BuildRequires:	php-pcre
BuildRequires:	php-xml
BuildRequires:	rpm-php-pearprov >= 4.4.2-30.1
BuildRequires:	rpmbuild(macros) >= 1.563
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	/usr/bin/php
Requires:	php(core) >= %{php_min_version}
Requires:	php(pcre)
Requires:	php(xml)
Requires:	php(zlib)
Requires:	php-pear >= 4:1.2-1
Requires:	php-pear-Archive_Tar >= 1.3.7
Requires:	php-pear-Console_Getopt >= 1.2
Requires:	php-pear-Structures_Graph >= 1.0.2
Requires:	php-pear-XML_Util >= 1.2.0
Requires:	rpm-whiteout
Suggests:	php-pear-Net_FTP
Obsoletes:	php-pear-PEAR-Command
Obsoletes:	php-pear-PEAR-Frontend_CLI
Obsoletes:	php-pear-PEAR-OS
Conflicts:	php-pear-PEAR_Frontend_Gtk < 0.4.0
Conflicts:	php-pear-PEAR_Frontend_Web < 0.5.0
Conflicts:	rpm-whiteout < 1.1
Conflicts:	rpmbuild(macros) < 1.563
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# PEAR_Command_Packaging is separate package
# PEAR_FTP is optional
%define		_noautoreq	'pear(PEAR/FTP.php)' 'pear(Net/FTP.php)' 'pear(XML/RPC.*)' 'pear(PEAR/Command/Packaging.php)'

%description
The PEAR package contains:
- the PEAR installer, for creating, distributing and installing
  packages
- the alpha-quality PEAR_Exception PHP5 error handling mechanism
- the beta-quality PEAR_ErrorStack advanced error handling mechanism
- the PEAR_Error error handling mechanism
- the OS_Guess class for retrieving info about the OS where PHP is
  running on
- the System class for quick handling of common operations with files
  and directories
- the PEAR base class packages

In PEAR status of this package is: %{_status}.

%description -l pl.UTF-8
Pakiet PEAR zawiara:
- PEAR installer do tworzenia, dystrybucji i instalowania pakietów,
- mechanizm PEAR_Exception (w fazie alpha) do obsługi błędów PHP5,
- zaawansowany mechanizm PEAR_ErrorStack (w fazie beta) do obsługi
  błędów,
- mechanizm obsługi błędów PEAR_Error,
- klasę OS_Guess do pozyskiwania informacji na temat systemu
  operacyjnego,
- klasę System do szybkiej obsługi typowych operacji na plikach i
  katalogach,
- podstawową klasy PEAR.

Ta klasa ma w PEAR status: %{_status}.

%package core
Summary:	PEAR core classes
Summary(pl.UTF-8):	Główne klasy PEAR-a
Group:		Development/Languages/PHP
Requires:	php(core) >= %{php_min_version}

%description core
This package includes PEAR core classes:
- PEAR class and PEAR_Error
- System
- OS_Guess
and classes for PHP 5:
- PEAR_ErrorStack and PEAR_Exception

%description core -l pl.UTF-8
Ten pakiet zawiera główne klasy PEAR-a:
- klasę PEAR i PEAR_Error
- System
- OS_Gueass
oraz klasy dla PHP 5:
- PEAR_ErrorStack i PEAR_Exception

%prep
%define __build_dir %{_builddir}/%{_pearname}-%{version}%{?_rc}
%define	__php_include_path %{__build_dir}/%{_pearname}-%{version}%{?_rc}:%{__build_dir}/%(basename %{SOURCE1} .tgz):%{__build_dir}/%(basename %{SOURCE2} .tgz)
%define __pear php -dmemory_limit=-1 -doutput_buffering=1 -dinclude_path="%__php_include_path" %{__build_dir}/%{_pearname}-%{version}%{?_rc}/scripts/pearcmd.php

%setup -q -c -n %{_pearname}-%{version} -a1 -a2
%pear_package_setup -z -D -n %{_pearname}-%{version}%{?_rc}

%patch0 -p1
%{?with_FHS:%patch5 -p1}

find '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v

%build
D=$(pwd)
pearcmd() {
	%{__pear} -c ${D}/pearrc "$@"
}
pearcmd config-set doc_dir %{_docdir}
pearcmd config-set data_dir %{php_pear_dir}/data
pearcmd config-set php_dir %{php_pear_dir}
pearcmd config-set test_dir %{php_pear_dir}/tests
pearcmd config-set sig_bin %{_bindir}/gpg
pearcmd config-set cfg_dir %{_sysconfdir}/pear

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir}/pear,%{php_pear_dir},%{_bindir}}
%pear_package_install
cp -a pearrc $RPM_BUILD_ROOT%{_sysconfdir}/pear.conf

# -C and -q options were for php-cgi, in php-cli they're enabled by default.
%define php_exec exec /usr/bin/php -dinclude_path=%{php_pear_dir} -doutput_buffering=1
cat > $RPM_BUILD_ROOT%{_bindir}/pear <<'EOF'
#!/bin/sh
%php_exec -dopen_basedir="" -dmemory_limit=128M %{php_pear_dir}/pearcmd.php "$@"
EOF
cat > $RPM_BUILD_ROOT%{_bindir}/peardev <<'EOF'
#!/bin/sh
%php_exec -dopen_basedir="" -dmemory_limit=-1 %{php_pear_dir}/pearcmd.php "$@"
EOF
# This -dextension=pcre.so works with php-5.1, and patched php-cli >= 4:5.0.5-18.1, php4-cli >= 3:4.4.1-6.1
# -n is there because devs on #pear said this avoids locking problems when replacing in use libraries.
cat > $RPM_BUILD_ROOT%{_bindir}/pecl <<'EOF'
#!/bin/sh
%php_exec -dmemory_limit=64M -dsafe_mode=0 -n -dextension=xml.so %{php_pear_dir}/peclcmd.php "$@"
EOF
# for rpm to find interpreter
chmod +x $RPM_BUILD_ROOT%{_bindir}/*

%post
if [ -f %{_docdir}/%{name}-%{version}/optional-packages.txt ]; then
	cat %{_docdir}/%{name}-%{version}/optional-packages.txt
fi

# need to bootstrap for non-root user
if [ ! -f %{php_pear_dir}/.lock ]; then
	umask 2
	%{_bindir}/pear list > /dev/null
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc install.log optional-packages.txt
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/pear.conf
%dir %{_sysconfdir}/pear
%attr(755,root,root) %{_bindir}/pear
%attr(755,root,root) %{_bindir}/peardev
%attr(755,root,root) %{_bindir}/pecl
%{php_pear_dir}/.registry/pear.reg
%{php_pear_dir}/pearcmd.php
%{php_pear_dir}/peclcmd.php
%{php_pear_dir}/PEAR/*

# in -core subpackage
%exclude %{php_pear_dir}/PEAR/ErrorStack.php
%exclude %{php_pear_dir}/PEAR/Exception.php
%exclude %{php_pear_dir}/PEAR/FixPHP5PEARWarnings.php

%{php_pear_dir}/data/*

%files core
%defattr(644,root,root,755)
%{php_pear_dir}/PEAR.php
%{php_pear_dir}/PEAR5.php
%{php_pear_dir}/System.php
%{php_pear_dir}/OS
%dir %{php_pear_dir}/PEAR
%{php_pear_dir}/PEAR/ErrorStack.php
%{php_pear_dir}/PEAR/Exception.php
%{php_pear_dir}/PEAR/FixPHP5PEARWarnings.php
%changelog
* Sun Aug 26 2012 Elan Ruusamäe <glen@delfi.ee> 9f4cd0e
- use php(core) for php engine version deps
- release 3 (by relup.sh)

* Wed Aug 08 2012 Elan Ruusamäe <glen@delfi.ee> afbfe78
keep BR deps package based, to ensure extension deps don't get mixed when building

* Tue Aug 07 2012 Elan Ruusamäe <glen@delfi.ee> 6cb5cae
- use virtual php extension deps (to be independant of php version)
- release 2 (by relup.sh)

* Sun Jul 31 2011 Elan Ruusamäe <glen@pld-linux.org> 0d40d47
- up to 1.9.4

* Fri Apr 08 2011 Elan Ruusamäe <glen@pld-linux.org> 5841667
- NOTE: CVE-2011-1144 still exists as 1.9.2 fix was incomplete

* Fri Apr 08 2011 Elan Ruusamäe <glen@pld-linux.org> ea6d061
- up to 1.9.2, CVE-2011-1072 php-pear: symlink vulnerability in PEAR

* Mon Aug 23 2010 Elan Ruusamäe <glen@pld-linux.org> c5a0a3b
- memory limit up to 128 for pear wrapper

* Sun Aug 22 2010 Elan Ruusamäe <glen@pld-linux.org> d95a135
- bootstrap lockfile for non-root; rel 3

* Sat Aug 21 2010 Elan Ruusamäe <glen@pld-linux.org> dbeea8a
- updated deps with pearize.sh
- release 2

* Tue Jul 20 2010 Elan Ruusamäe <glen@pld-linux.org> f904047
- release 1

* Tue Jun 22 2010 arvenil <arvenil@pld-linux.org> 37aecd6
- up to 1.9.1

* Thu May 20 2010 Elan Ruusamäe <glen@pld-linux.org> 27a20fa
- up to 1.9.0, force php5 as min ver

* Wed Mar 10 2010 Elan Ruusamäe <glen@pld-linux.org> 8066c12
- channels registry moved to php-pear package completely; rel 10

* Wed Jan 20 2010 Elan Ruusamäe <glen@pld-linux.org> fa703ae
- setup and use cfg_dir as /etc/pear; rel 9

* Thu Jan 29 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 3bb4eaa
- rel 8; bump memory limit from 24MB to 64MB

* Wed Dec 10 2008 Elan Ruusamäe <glen@pld-linux.org> 8f85834
- channelsdir and channel aliases dir moved to php-pear; rel 7

* Tue Dec 09 2008 Elan Ruusamäe <glen@pld-linux.org> bcc47e2
- revert ... wrong package

* Tue Dec 09 2008 Elan Ruusamäe <glen@pld-linux.org> 7d4af4b
- package extra channel dirs; rel 6

* Thu May 29 2008 Elan Ruusamäe <glen@pld-linux.org> 3c98fb1
- depend on rpm-whiteout to get proper dependency whiteout macro
- NOTE: do not convert to R>version, as then dependency could be solved in same transaction and rpm doesn't read new macros

* Mon May 19 2008 Elan Ruusamäe <glen@pld-linux.org> 939cbf7
- restore exec bits on scripts; rel 4

